gtkmm: Gtk::PrintContext Class Reference

gtkmm 4.2.0

Public Member Functions | Static Public Member Functions | Related Functions | List of all members
Gtk::PrintContext Class Reference
Printing

A PrintContext encapsulates context information that is required when drawing pages for printing, such as the cairo context and important parameters like page size and resolution. More...

`#include <gtkmm/printcontext.h>`

Inheritance diagram for Gtk::PrintContext:
[legend]

## Public Member Functions
| PrintContext (PrintContext&& src) noexcept
PrintContext& | operator= (PrintContext&& src) noexcept
| ~PrintContext () noexcept override
GtkPrintContext* | gobj ()
| Provides access to the underlying C GObject. More...
const GtkPrintContext* | gobj () const
| Provides access to the underlying C GObject. More...
GtkPrintContext* | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs. More...
Cairo::RefPtr< Cairo::Context > | get_cairo_context ()
| Obtains the cairo context that is associated with the `GtkPrintContext`. More...
Cairo::RefPtr< const Cairo::Context > | get_cairo_context () const
| Obtains the cairo context that is associated with the `GtkPrintContext`. More...
Glib::RefPtr< PageSetup > | get_page_setup ()
| Obtains the `GtkPageSetup` that determines the page dimensions of the `GtkPrintContext`. More...
Glib::RefPtr< const PageSetup > | get_page_setup () const
| Obtains the `GtkPageSetup` that determines the page dimensions of the `GtkPrintContext`. More...
double | get_width () const
| Obtains the width of the `GtkPrintContext`, in pixels. More...
double | get_height () const
| Obtains the height of the `GtkPrintContext`, in pixels. More...
double | get_dpi_x () const
| Obtains the horizontal resolution of the `GtkPrintContext`, in dots per inch. More...
double | get_dpi_y () const
| Obtains the vertical resolution of the `GtkPrintContext`, in dots per inch. More...
bool | get_hard_margins (double& top, double& bottom, double&left, double&right) const
| Obtains the hardware printer margins of the `GtkPrintContext`, in units. More...
Glib::RefPtr< Pango::FontMap > | get_pango_fontmap ()
| Returns a `PangoFontMap` that is suitable for use with the `GtkPrintContext`. More...
Glib::RefPtr< const Pango::FontMap > | get_pango_fontmap () const
| Returns a `PangoFontMap` that is suitable for use with the `GtkPrintContext`. More...
Glib::RefPtr< Pango::Context > | create_pango_context ()
| Creates a new `PangoContext` that can be used with the `GtkPrintContext`. More...
Glib::RefPtr< Pango::Layout > | create_pango_layout ()
| Creates a new `PangoLayout` that is suitable for use with the `GtkPrintContext`. More...
void | set_cairo_context (const Cairo::RefPtr< Cairo::Context >& cr, double dpi_x, double dpi_y)
| Sets a new cairo context on a print context. More...
Public Member Functions inherited from Glib::Object
| Object (const Object &)=delete
Object & | operator= (const Object &)=delete
| Object (Object &&src) noexcept
Object & | operator= (Object &&src) noexcept
void * | get_data (const QueryQuark &key)
void | set_data (const Quark &key, void *data)
void | set_data (const Quark &key, void *data, DestroyNotify notify)
void | remove_data (const QueryQuark &quark)
void * | steal_data (const QueryQuark &quark)
Glib::RefPtr< Glib::Object > | wrap (GObject *object, bool take_copy=false)
Public Member Functions inherited from Glib::ObjectBase
| ObjectBase (const ObjectBase &)=delete
ObjectBase & | operator= (const ObjectBase &)=delete
void | set_property_value (const Glib::ustring &property_name, const Glib::ValueBase &value)
void | get_property_value (const Glib::ustring &property_name, Glib::ValueBase &value) const
void | set_property (const Glib::ustring &property_name, const PropertyType &value)
void | get_property (const Glib::ustring &property_name, PropertyType &value) const
PropertyType | get_property (const Glib::ustring &property_name) const
sigc::connection | connect_property_changed (const Glib::ustring &property_name, const sigc::slot< void()> &slot)
sigc::connection | connect_property_changed (const Glib::ustring &property_name, sigc::slot< void()> &&slot)
void | freeze_notify ()
void | thaw_notify ()
virtual void | reference () const
virtual void | unreference () const
GObject * | gobj ()
const GObject * | gobj () const
GObject * | gobj_copy () const

## Static Public Member Functions
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system. More...

## Related Functions
(Note that these are not member functions.)
Glib::RefPtr< Gtk::PrintContext > | wrap (GtkPrintContext* object, bool take_copy=false)
| A Glib::wrap() method for this object. More...

## Additional Inherited Members
Public Types inherited from Glib::Object
typedef void(*)(gpointer data | DestroyNotify)
Protected Member Functions inherited from Glib::Object
| Object ()
| Object (const Glib::ConstructParams &construct_params)
| Object (GObject *castitem)
| ~Object () noexcept override
Protected Member Functions inherited from Glib::ObjectBase
| ObjectBase ()
| ObjectBase (const char *custom_type_name)
| ObjectBase (const std::type_info &custom_type_info)
| ObjectBase (ObjectBase &&src) noexcept
ObjectBase & | operator= (ObjectBase &&src) noexcept
virtual | ~ObjectBase () noexcept=0
void | initialize (GObject *castitem)
void | initialize_move (GObject *castitem, Glib::ObjectBase *previous_wrapper)

## Detailed Description

A PrintContext encapsulates context information that is required when drawing pages for printing, such as the cairo context and important parameters like page size and resolution.

It also lets you easily create Pango::Layout and Pango::Context objects that match the font metrics of the cairo surface.

PrintContext objects gets passed to the begin-print, end-print, request-page-setup and draw-page signals on the PrintOperation.

Since gtkmm 2.10:

## Constructor & Destructor Documentation

## ◆ PrintContext()

Gtk::PrintContext::PrintContext | ( | PrintContext&& | src | ) |
| noexcept

## ◆ ~PrintContext()

Gtk::PrintContext::~PrintContext | ( |  | ) |
| overridenoexcept

## Member Function Documentation

## ◆ create_pango_context()

Glib::RefPtr<Pango::Context> Gtk::PrintContext::create_pango_context | ( |  | ) |

Creates a new `PangoContext` that can be used with the `GtkPrintContext`.

Returns
  A new Pango context for context.

## ◆ create_pango_layout()

Glib::RefPtr<Pango::Layout> Gtk::PrintContext::create_pango_layout | ( |  | ) |

Creates a new `PangoLayout` that is suitable for use with the `GtkPrintContext`.

Returns
  A new Pango layout for context.

## ◆ get_cairo_context() [1/2]

Cairo::RefPtr<Cairo::Context> Gtk::PrintContext::get_cairo_context | ( |  | ) |

Obtains the cairo context that is associated with the `GtkPrintContext`.

Returns
  The cairo context of context.

## ◆ get_cairo_context() [2/2]

Cairo::RefPtr<const Cairo::Context> Gtk::PrintContext::get_cairo_context | ( |  | ) | const

Obtains the cairo context that is associated with the `GtkPrintContext`.

Returns
  The cairo context of context.

## ◆ get_dpi_x()

double Gtk::PrintContext::get_dpi_x | ( |  | ) | const

Obtains the horizontal resolution of the `GtkPrintContext`, in dots per inch.

Returns
  The horizontal resolution of context.

## ◆ get_dpi_y()

double Gtk::PrintContext::get_dpi_y | ( |  | ) | const

Obtains the vertical resolution of the `GtkPrintContext`, in dots per inch.

Returns
  The vertical resolution of context.

## ◆ get_hard_margins()

bool Gtk::PrintContext::get_hard_margins | ( | double & | top,
|  | double & | bottom,
|  | double & | left,
|  | double & | right
| ) |  | const

Obtains the hardware printer margins of the `GtkPrintContext`, in units.

Parameters

  top | Top hardware printer margin.
  bottom | Bottom hardware printer margin.
  left | Left hardware printer margin.
  right | Right hardware printer margin.

Returns
  `true` if the hard margins were retrieved.

## ◆ get_height()

double Gtk::PrintContext::get_height | ( |  | ) | const

Obtains the height of the `GtkPrintContext`, in pixels.

Returns
  The height of context.

## ◆ get_page_setup() [1/2]

Glib::RefPtr<PageSetup> Gtk::PrintContext::get_page_setup | ( |  | ) |

Obtains the `GtkPageSetup` that determines the page dimensions of the `GtkPrintContext`.

Returns
  The page setup of context.

## ◆ get_page_setup() [2/2]

Glib::RefPtr<const PageSetup> Gtk::PrintContext::get_page_setup | ( |  | ) | const

Obtains the `GtkPageSetup` that determines the page dimensions of the `GtkPrintContext`.

Returns
  The page setup of context.

## ◆ get_pango_fontmap() [1/2]

Glib::RefPtr<Pango::FontMap> Gtk::PrintContext::get_pango_fontmap | ( |  | ) |

Returns a `PangoFontMap` that is suitable for use with the `GtkPrintContext`.

Returns
  The font map of context.

## ◆ get_pango_fontmap() [2/2]

Glib::RefPtr<const Pango::FontMap> Gtk::PrintContext::get_pango_fontmap | ( |  | ) | const

Returns a `PangoFontMap` that is suitable for use with the `GtkPrintContext`.

Returns
  The font map of context.

## ◆ get_type()

static GType Gtk::PrintContext::get_type | ( |  | ) |
| static

Get the GType for this class, for use with the underlying GObject type system.

## ◆ get_width()

double Gtk::PrintContext::get_width | ( |  | ) | const

Obtains the width of the `GtkPrintContext`, in pixels.

Returns
  The width of context.

## ◆ gobj() [1/2]

GtkPrintContext* Gtk::PrintContext::gobj | ( |  | ) |
| inline

Provides access to the underlying C GObject.

## ◆ gobj() [2/2]

const GtkPrintContext* Gtk::PrintContext::gobj | ( |  | ) | const
| inline

Provides access to the underlying C GObject.

## ◆ gobj_copy()

GtkPrintContext* Gtk::PrintContext::gobj_copy | ( |  | ) |

Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.

## ◆ operator=()

PrintContext& Gtk::PrintContext::operator= | ( | PrintContext&& | src | ) |
| noexcept

## ◆ set_cairo_context()

void Gtk::PrintContext::set_cairo_context | ( | const Cairo::RefPtr< Cairo::Context > & | cr,
|  | double | dpi_x,
|  | double | dpi_y
| ) |  |

Sets a new cairo context on a print context.

This function is intended to be used when implementing an internal print preview, it is not needed for printing, since GTK itself creates a suitable cairo context in that case.

Parameters

  cr | The cairo context.
  dpi_x | The horizontal resolution to use with cr.
  dpi_y | The vertical resolution to use with cr.

## Friends And Related Function Documentation

## ◆ wrap()

Glib::RefPtr< Gtk::PrintContext > wrap | ( | GtkPrintContext * | object,
|  | bool | take_copy = `false`
| ) |  |
| related

A Glib::wrap() method for this object.

Parameters

  object | The C instance.
  take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns
  A C++ instance that wraps this C instance.